function varargout = KerMet_Toy(varargin)
% KERMET_TOY M-file for KerMet_Toy.fig
%      KERMET_TOY, by itself, creates a new KERMET_TOY or raises the existing
%      singleton*.
%
%      H = KERMET_TOY returns the handle to a new KERMET_TOY or the handle to
%      the existing singleton*.
%
%      KERMET_TOY('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in KERMET_TOY.M with the given input arguments.
%
%      KERMET_TOY('Property','Value',...) creates a new KERMET_TOY or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before KerMet_Toy_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to KerMet_Toy_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help KerMet_Toy

% Last Modified by GUIDE v2.5 08-Aug-2005 09:21:46

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @KerMet_Toy_OpeningFcn, ...
                   'gui_OutputFcn',  @KerMet_Toy_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before KerMet_Toy is made visible.
function KerMet_Toy_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to KerMet_Toy (see VARARGIN)

% Choose default command line output for KerMet_Toy
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes KerMet_Toy wait for user response (see UIRESUME)
% uiwait(handles.KerMet_Toy);
ud.origin = [0,0]'; % origin for DS-kernels
ud.center = [0,0]'; % center of trafos
ud.X = [0.5,1]';
ud.y = [1];
ud.plot_point_mode = '';
ud.helpwindow = 0;
% set default values for multiple-used edit-fields
ud.beta = 1;
ud.b = 1;
ud.gamma = 1;
ud.p = 1; % positive part of signature of indefinite kernel
ud.deg = 2; % degree of pol-kernel
ud.nneigh = 1; % number of neighbours in k-nn
ud.C = 1000; % C for C-SVM
ud.nu = 0.5; % nu for hypershpere
ud.max_nupdates = 1; % number of updates of perceptron
ud.KPCAind = 1; % kernel PCA component
ud.dx = 0.5;
ud.dy = 0.5;
ud.dxy = 0.5;
ud.phi = 0.5;
ud.scale = 0.5;
ud.dphi = 0.5;
ud.nfeval = 3;
ud.nTDtype = 3; % Mean TD
set(hObject,'Userdata',ud);
set(gcf,'DoubleBuffer','on');

plot_invariant_kernel_method(hObject);

% --- Outputs from this function are returned to the command line.
function varargout = KerMet_Toy_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%% "base kernel" options and uicontrols  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes during object creation, after setting all properties.
function base_kernel_type_popupmenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to base_kernel_type_popupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in base_kernel_type_popupmenu.
function base_kernel_type_popupmenu_Callback(hObject, eventdata, handles)
% hObject    handle to base_kernel_type_popupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns base_kernel_type_popupmenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from base_kernel_type_popupmenu

ud = get(gcbf,'userdata');
val = get(gcbo,'Value');
par1 = findobj(gcbf,'Tag','base_kernel_parameter_1_text');
par2 = findobj(gcbf,'Tag','base_kernel_parameter_2_text');
par1_edit = findobj(gcbf,'Tag','base_kernel_parameter_1_edit');
par2_edit = findobj(gcbf,'Tag','base_kernel_parameter_2_edit');
switch val
 case 1, % linear kernel
  set(par1,'String','bias');
  set(par1_edit,'Value',ud.b);
  set(par1_edit,'String',num2str(ud.b));  
  set(par2,'Visible','off');
  set(par2_edit,'Visible','off');
 case 2, % polynomial kernel
  set(par1,'String','bias');
  set(par1_edit,'Value',ud.b);
  set(par1_edit,'String',num2str(ud.b));  
  set(par2,'String','degree');
  set(par2_edit,'Value',ud.deg);
  set(par2_edit,'String',num2str(ud.deg));  
  set(par2,'Visible','on');
  set(par2_edit,'Visible','on');
 case 3, % rbf kernel
  set(par1,'String','gamma');
  set(par1_edit,'Value',ud.gamma);
  set(par1_edit,'String',num2str(ud.gamma));  
%  if 0==get(par1_edit,'Value')
%    set(par1_edit,'Value',1.0);
%    set(par1_edit,'String','1.0');
%  end;
  set(par2,'Visible','off');
  set(par2_edit,'Visible','off');
 case 4, % triangular/negative distance kernel
  set(par1,'String','beta');
  set(par1_edit,'Value',ud.beta);
  set(par1_edit,'String',num2str(ud.beta));  
  set(par2,'Visible','off');
  set(par2_edit,'Visible','off');
 case 5, % pseudo-euclidean inner product
  set([par1,par2,par1_edit,par2_edit],'Visible','on');
  set(par1,'String','bias');
  set(par1_edit,'Value',ud.b);
  set(par1_edit,'String',num2str(ud.b));  
  set(par2,'String','p of signature');
  set(par2_edit,'Value',ud.p);
  set(par2_edit,'String',num2str(ud.p));  
end;

plot_invariant_kernel_method(gcbf);

% --- Executes during object creation, after setting all properties.
function base_kernel_parameter_1_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to base_kernel_parameter_1_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function base_kernel_parameter_1_edit_Callback(hObject, eventdata, handles)
% hObject    handle to base_kernel_parameter_1_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of base_kernel_parameter_1_edit as text
%        str2double(get(hObject,'String')) returns contents of base_kernel_parameter_1_edit as a double

update_edit_and_plot(gcbo,gcbf);


% --- Executes during object creation, after setting all properties.
function base_kernel_parameter_2_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to base_kernel_parameter_2_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function base_kernel_parameter_2_edit_Callback(hObject, eventdata, handles)
% hObject    handle to base_kernel_parameter_2_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of base_kernel_parameter_2_edit as text
%        str2double(get(hObject,'String')) returns contents of base_kernel_parameter_2_edit as a double

update_edit_and_plot(gcbo,gcbf);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%% "invariant kernel" options and uicontrols  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes during object creation, after setting all properties.
function kernel_type_popupmenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to kernel_type_popupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in kernel_type_popupmenu.
function kernel_type_popupmenu_Callback(hObject, eventdata, handles)
% hObject    handle to kernel_type_popupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns kernel_type_popupmenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from kernel_type_popupmenu
ud = get(gcbf,'userdata');
val = get(gcbo,'Value');
par1 = findobj(gcbf,'Tag','kernel_parameter_1_text');
par2 = findobj(gcbf,'Tag','kernel_parameter_2_text');
par3 = findobj(gcbf,'Tag','kernel_parameter_3_text');
par1_edit = findobj(gcbf,'Tag','kernel_parameter_1_edit');
par2_edit = findobj(gcbf,'Tag','kernel_parameter_2_edit');
par3_edit = findobj(gcbf,'Tag','kernel_parameter_3_edit');
origin_pushbutton = findobj(gcbf,'Tag','kernel_set_DS_origin_pushbutton');
tangcb = findobj(gcbf,'Tag','kernel_plot_tangents_checkbox');
refl_checkbox = findobj(gcbf,'Tag','transformation_reflection_checkbox');
switch val
 case 1,  % no invariance
  set([par1,par2,par3,par1_edit,par2_edit,par3_edit,tangcb,origin_pushbutton],'Visible','off'); 
 case 4,  % TD-kernels
  set([par1,par2,par3,par1_edit,par2_edit,tangcb,origin_pushbutton],'Visible','on');
%  set([refl_checkbox],'Visible','off');
  v = get(refl_checkbox,'Value');
  if v==1
    disp('Reflection not possible for TD-kernels, switching off...');
    set(refl_checkbox,'Value',0);
  end;
  set(par1,'String','Distance Mode');
  set(par1_edit,'String',{'2S','1S','MN','MP'});
  set(par1_edit,'Value',ud.nTDtype);
  v = get(par1_edit,'Value');
  if isempty(v) | isempty(find(v(1)==[1 2 3 4]));
    set(par1_edit,'Value',1);
  end;
  set(par1_edit,'Style','popupmenu');
  set(par2,'String','Regularization lambda');
%  set(par2_edit,'String','0.0');
%  set(par2_edit,'Value',0.0);  
  set(par3,'Style','checkbox');  
  set(par3,'String','normalize tangents');
 case 2  % HI-kernels
  set([par1,par1_edit,refl_checkbox],'Visible','on');
  set([par2,par3,par2_edit,tangcb,origin_pushbutton],'Visible','off');  
  set(par1,'String','trafo-evals');
  set(par1_edit,'Style','edit');
  set(par1_edit,'String',num2str(ud.nfeval));  
  set(par1_edit,'Value',ud.nfeval);  
  v = get(par1_edit,'Value');
  if isempty(v) | v(1)<3;
    set(par1_edit,'Value',3);
  end;
  v = get(par1_edit,'Value');
  set(par1_edit,'String',num2str(v)); 
 case 3  % IDS-kernels
  set([par1,par1_edit,par2,par2_edit,refl_checkbox,origin_pushbutton],...
      'Visible','on');
  set([par3,tangcb],'Visible','off');  
  set(par1,'String','trafo-evals');
  set(par1_edit,'Style','edit');
  v = get(par1_edit,'Value');
  if isempty(v)  | v(1)<3;
    set(par1_edit,'Value',3);
  end;
  v = get(par1_edit,'Value');
  set(par1_edit,'String',num2str(v)); 
  set(par2,'String','Regularization lambda');
%  set(par2_edit,'String','0.0');
%  set(par2_edit,'Value',0.0);  
 otherwise
  set([par1,par2,par3,par1_edit,par2_edit,par3_edit,tangcb,...
       refl_checkbox,origin_pushbutton],'Visible','off');
  error('kernel not yet implemented');
end;

plot_invariant_kernel_method(gcbf);

% --- Executes during object creation, after setting all properties.
function kernel_parameter_1_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to kernel_parameter_1_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on button press in kernel_set_DS_origin_pushbutton.
function kernel_set_DS_origin_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to kernel_set_DS_origin_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

ud = get(gcbf,'userdata');
ud.plot_point_mode = 'origin';
set(gcbf,'userdata',ud);
%plot_invariant_kernel_method(gcbf);

% --- Executes during object creation, after setting all properties.
function kernel_set_DS_origin_pushbutton_CreateFcn(hObject, eventdata, handles)
% hObject    handle to kernel_set_DS_origin_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


function kernel_parameter_1_edit_Callback(hObject, eventdata, handles)
% hObject    handle to kernel_parameter_1_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of kernel_parameter_1_edit as text
%        str2double(get(hObject,'String')) returns contents of kernel_parameter_1_edit as a double

update_edit_and_plot(gcbo,gcbf);

% --- Executes during object creation, after setting all properties.
function kernel_parameter_2_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to kernel_parameter_2_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function kernel_parameter_2_edit_Callback(hObject, eventdata, handles)
% hObject    handle to kernel_parameter_2_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of kernel_parameter_2_edit as text
%        str2double(get(hObject,'String')) returns contents of kernel_parameter_2_edit as a double

update_edit_and_plot(gcbo,gcbf);

% --- Executes during object creation, after setting all properties.
function kernel_parameter_3_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to kernel_parameter_3_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


function kernel_parameter_3_edit_Callback(hObject, eventdata, handles)
% hObject    handle to kernel_parameter_3_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of kernel_parameter_3_edit as text
%        str2double(get(hObject,'String')) returns contents of kernel_parameter_3_edit as a double

update_edit_and_plot(gcbo,gcbf);

% --------------------------------------------------------------------
function kernel_parameter_3_text_Callback(hObject, eventdata, handles)
% hObject    handle to kernel_parameter_3_text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

plot_invariant_kernel_method(gcbf);


% --- Executes on button press in kernel_plot_tangents_checkbox.
function kernel_plot_tangents_checkbox_Callback(hObject, eventdata, handles)
% hObject    handle to kernel_plot_tangents_checkbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of kernel_plot_tangents_checkbox

update_edit_and_plot(gcbo,gcbf);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%% "transformation" options and uicontrols  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes during object creation, after setting all properties.
function transformation_popupmenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to transformation_popupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in transformation_popupmenu.
function transformation_popupmenu_Callback(hObject, eventdata, handles)
% hObject    handle to transformation_popupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns transformation_popupmenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from transformation_popupmenu
ud = get(gcbf,'userdata');
val = get(gcbo,'Value');
par1 = findobj(gcbf,'Tag','transformation_parameter_1_text');
par2 = findobj(gcbf,'Tag','transformation_parameter_2_text');
par1_edit = findobj(gcbf,'Tag','transformation_parameter_1_edit');
par2_edit = findobj(gcbf,'Tag','transformation_parameter_2_edit');
refl_checkbox = findobj(gcbf,'Tag','transformation_reflection_checkbox');
plot_trafo_checkbox = findobj(gcbf,'Tag','transformation_plot_checkbox');
center_pushbutton = findobj(gcbf,'Tag','transformation_set_trafo_center_pushbutton');
switch val
 case 1
  set([par1,par2,par1_edit,par2_edit,center_pushbutton],'Visible','off');
  set([refl_checkbox,plot_trafo_checkbox],'Visible','on');
 case 2
  set([par1,par1_edit,refl_checkbox,plot_trafo_checkbox,center_pushbutton],'Visible','on');
  set([par2,par2_edit],'Visible','off');
  set(par1,'String','dx');
  set(par1_edit,'Value',ud.dx);
  set(par1_edit,'String',num2str(ud.dx));  
 case 3
  set([par1,par1_edit,refl_checkbox,plot_trafo_checkbox,center_pushbutton],'Visible','on');
  set(par1,'String','dy');
  set(par1_edit,'Value',ud.dy);
  set(par1_edit,'String',num2str(ud.dy));  
  set([par2,par2_edit],'Visible','off');
 case 4
  set([par1,par1_edit,refl_checkbox,plot_trafo_checkbox,center_pushbutton],'Visible','on');
  set([par2,par2_edit],'Visible','off');
  set(par1,'String','dxy');
  set(par1_edit,'Value',ud.dxy);
  set(par1_edit,'String',num2str(ud.dxy));  
 case 5
  set([par1,par1_edit,center_pushbutton,refl_checkbox,plot_trafo_checkbox],'Visible','on');
  set([par2,par2_edit],'Visible','off');
  set(par1,'String','phi');
  set(par1_edit,'Value',ud.phi);
  set(par1_edit,'String',num2str(ud.phi));  
 case 6
  set([par1,par1_edit,center_pushbutton,refl_checkbox,plot_trafo_checkbox],'Visible','on');
  set([par2,par2_edit],'Visible','off');
  set(par1,'String','scale');
  set(par1_edit,'Value',ud.scale);
  set(par1_edit,'String',num2str(ud.scale));  
 case 7
  set([par1,par1_edit,refl_checkbox,plot_trafo_checkbox,center_pushbutton],'Visible','on');
  set([par2,par2_edit],'Visible','off');
  set(par1,'String','dphi');
  set(par1_edit,'Value',ud.dphi);
  set(par1_edit,'String',num2str(ud.dphi));  
 case 8
  set([par1,par2,par1_edit,par2_edit,center_pushbutton,refl_checkbox,...
       plot_trafo_checkbox],'Visible','on');
  set(par1,'String','dxy');
  set(par1_edit,'Value',ud.dxy);
  set(par1_edit,'String',num2str(ud.dxy));  
  set(par2,'String','phi');
  set(par2_edit,'Value',ud.phi);
  set(par2_edit,'String',num2str(ud.phi));  
end;
plot_invariant_kernel_method(gcbf);


% --- Executes during object creation, after setting all properties.
function transformation_reflection_checkbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to transformation_reflection_checkbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in transformation_reflection_checkbox.
function transformation_reflection_checkbox_Callback(hObject, eventdata, handles)
% hObject    handle to transformation_reflection_checkbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns transformation_reflection_checkbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from transformation_reflection_checkbox

% prevent TD-kernels and reflection
if get(gcbo,'Value')==1 & ...
      get(findobj(gcbf,'Tag','kernel_type_popupmenu'),'Value')==4
  disp('Reflection not possible for TD-kernels, switching off...');
  set(gcbo,'Value',0);
  return;
end;
% set visibiliy of center-set button
if get(gcbo,'Value')==1
  set(findobj(gcbf,'Tag','transformation_set_trafo_center_pushbutton'),...
      'Visible','on')
else
  if ismember(get(findobj(gcbf,'Tag','transformation_popupmenu'),...
		    'Value'),[1,2,3,4,7])
  set(findobj(gcbf,'Tag','transformation_set_trafo_center_pushbutton'),...
      'Visible','off') 
  end;
end;
plot_invariant_kernel_method(gcbf);

% --- Executes during object creation, after setting all properties.
function transformation_parameter_1_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to transformation_parameter_1_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function transformation_parameter_1_edit_Callback(hObject, eventdata, handles)
% hObject    handle to transformation_parameter_1_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of transformation_parameter_1_edit as text
%        str2double(get(hObject,'String')) returns contents of transformation_parameter_1_edit as a double

update_edit_and_plot(gcbo,gcbf);

% --- Executes during object creation, after setting all properties.
function transformation_parameter_2_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to transformation_parameter_2_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function transformation_parameter_2_edit_Callback(hObject, eventdata, handles)
% hObject    handle to transformation_parameter_2_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of transformation_parameter_2_edit as text
%        str2double(get(hObject,'String')) returns contents of transformation_parameter_2_edit as a double

update_edit_and_plot(gcbo,gcbf);

% --- Executes on button press in transformation_set_trafo_center_pushbutton.
function transformation_set_trafo_center_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to transformation_set_trafo_center_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

ud = get(gcbf,'userdata');
ud.plot_point_mode = 'center';
set(gcbf,'userdata',ud);
%plot_invariant_kernel_method(gcbf);

% --- Executes during object creation, after setting all properties.
function transformation_set_trafo_center_pushbutton_CreateFcn(hObject, eventdata, handles)
% hObject    handle to transformation_set_trafo_center_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% --- Executes on button press in transformation_plot_checkbox.
function transformation_plot_checkbox_Callback(hObject, eventdata, handles)
% hObject    handle to transformation_plot_checkbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of transformation_plot_checkbox

update_edit_and_plot(gcbo,gcbf);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%% "plot" options and uicontrols  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes during object creation, after setting all properties.
function plot_mode_popupmenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to plot_mode_popupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in plot_mode_popupmenu.
function plot_mode_popupmenu_Callback(hObject, eventdata, handles)
% hObject    handle to plot_mode_popupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns plot_mode_popupmenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from plot_mode_popupmenu

plot_invariant_kernel_method(gcbf);

% --- Executes during object creation, after setting all properties.
function plot_parameter_1_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to plot_parameter_1_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


function plot_parameter_1_edit_Callback(hObject, eventdata, handles)
% hObject    handle to plot_parameter_1_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of plot_parameter_1_edit as text
%        str2double(get(hObject,'String')) returns contents of plot_parameter_1_edit as a double

update_edit_and_plot(gcbo,gcbf);


% --- Executes during object creation, after setting all properties.
function plot_parameter_2_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to plot_parameter_2_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function plot_parameter_2_edit_Callback(hObject, eventdata, handles)
% hObject    handle to plot_parameter_2_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of plot_parameter_2_edit as text
%        str2double(get(hObject,'String')) returns contents of plot_parameter_2_edit as a double

update_edit_and_plot(gcbo,gcbf);

% --- Executes during object creation, after setting all properties.
function plot_mode_immediate_checkbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to plot_mode_immediate_checkbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on button press in plot_mode_immediate_checkbox.
function plot_mode_immediate_checkbox_Callback(hObject, eventdata, handles)
% hObject    handle to plot_mode_immediate_checkbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of plot_mode_immediate_checkbox

if get(gcbo,'Value')==0
  set(findobj(gcbf,'Tag','plot_mode_replot_pushbutton'),'visible','on');
else
  set(findobj(gcbf,'Tag','plot_mode_replot_pushbutton'),'visible','off');
end;

plot_invariant_kernel_method(gcbf);

% --- Executes during object creation, after setting all properties.
function plot_mode_replot_pushbutton_CreateFcn(hObject, eventdata, handles)
% hObject    handle to plot_mode_replot_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% --- Executes on button press in plot_mode_replot_pushbutton.
function plot_mode_replot_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to plot_mode_replot_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

plot_invariant_kernel_method(gcf,1); % force plot

% --- Executes during object creation, after setting all properties.
function plot_mode_grid_resolution_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to plot_mode_grid_resolution_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


function plot_mode_grid_resolution_edit_Callback(hObject, eventdata, handles)
% hObject    handle to plot_mode_grid_resolution_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of plot_mode_grid_resolution_edit as text
%        str2double(get(hObject,'String')) returns contents of plot_mode_grid_resolution_edit as a double

update_edit_and_plot(gcbo,gcbf);


% --- Executes on button press in plot_mode_help_pushbutton.
function plot_mode_help_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to plot_mode_help_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% search callback-figure by hand as routine is called from help-window
cbf = findobj(0,'Tag','KerMet_Toy');
ud = get(cbf,'Userdata');
%if ud.helpwindow == 0
%  disp('first help-window');
helptext = textread('KerMet_Toy.txt','%s','delimiter','\n','whitespace','');
lines_per_window = 40;
% if not last window
if length(helptext)>(ud.helpwindow+1)*lines_per_window 
%  disp('not last window');
  lb = ud.helpwindow*lines_per_window +1;
  h = msgbox(helptext(lb:(lb+lines_per_window-1)),'Help KerMet_Toy');
  c = get(h,'Children');
  set(c(2),'String','More');
  cbo = findobj(gcbo);
  set(c(2),'Callback',['delete(gcbf);',...
	'cbo = findobj(1,''Tag'',''plot_mode_help_pushbutton'');',...
	'KerMet_Toy(''plot_mode_help_pushbutton_Callback'' ',...
	',cbo,[],guidata(cbo))']);
  ud.helpwindow = ud.helpwindow+1;
else   % if last window
%  disp('last window');
%  keyboard;
  lb = ud.helpwindow*lines_per_window +1;
  h = msgbox(helptext(lb:length(helptext)),'Help KerMet_Toy');
  ud.helpwindow = 0;
end;
set(cbf,'Userdata',ud);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%% "kernel method" options and uicontrols  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes during object creation, after setting all properties.
function kernel_method_popupmenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to kernel_method_popupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in kernel_method_popupmenu.
function kernel_method_popupmenu_Callback(hObject, eventdata, handles)
% hObject    handle to kernel_method_popupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns kernel_method_popupmenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from kernel_method_popupmenu

ud = get(gcbf,'userdata');
kernel_method = get(gcbo,'Value');
par1 = findobj(gcbf,'Tag','kernel_method_parameter1_text');
par2 = findobj(gcbf,'Tag','kernel_method_parameter2_text');
par1_edit = findobj(gcbf,'Tag','kernel_method_parameter1_edit');
par2_edit = findobj(gcbf,'Tag','kernel_method_parameter2_edit');
par2_inc = findobj(gcbf,'Tag','kernel_method_parameter2_inc_pushbutton');
par2_dec = findobj(gcbf,'Tag','kernel_method_parameter2_dec_pushbutton');
switch kernel_method
 case 1 % single kernel plot
  set([par1,par2,par1_edit,par2_edit,par2_inc,par2_dec],...
      'Visible','off');
 case 2 % kernel k-nearest-neighbour 
  set([par1,par1_edit],'Visible','on');
  set([par2,par2_edit,par2_inc,par2_dec],'Visible','off');
  set(par1,'String','number of neighbours');
  set(par1_edit,'Value',ud.nneigh);
  set(par1_edit,'String',num2str(ud.nneigh));  
 case 3 % SVM
  set([par1,par1_edit],'Visible','on');
  set([par2,par2_edit,par2_inc,par2_dec],'Visible','off');
  set(par1,'String','penalization C');
  set(par1_edit,'Value',ud.C);
  set(par1_edit,'String',num2str(ud.C));  
 case 4 % Kernel Perceptron
  set([par2,par2_edit,par2_inc,par2_dec],'Visible','on');
  set([par1,par1_edit],'Visible','off');
  set(par2,'String','Training update steps');
  set(par2_edit,'Value',ud.max_nupdates);
  set(par2_edit,'String',num2str(ud.max_nupdates));  
 case 5 % Kernel PCA
  set([par2,par2_edit,par2_inc,par2_dec],'Visible','on');
  set([par1,par1_edit],'Visible','off');
  set(par2,'String','PCA Component');
  set(par2_edit,'Value',ud.KPCAind);
  set(par2_edit,'String',num2str(ud.KPCAind));  
 case 6 % novelty detection
  set([par1,par1_edit],'Visible','on');
  set([par2,par2_edit,par2_inc,par2_dec],'Visible','off');
  set(par1,'String','estimated SV rate nu');
  set(par1_edit,'Value',ud.nu);
  set(par1_edit,'String',num2str(ud.nu));  
 otherwise
  disp('visibility setting not implemented for kernel method');
end;
plot_invariant_kernel_method(gcbf);

% --- Executes during object creation, after setting all properties.
function kernel_method_parameter1_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to kernel_method_parameter1_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function kernel_method_parameter1_edit_Callback(hObject, eventdata, handles)
% hObject    handle to kernel_method_parameter1_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of kernel_method_parameter1_edit as text
%        str2double(get(hObject,'String')) returns contents of kernel_method_parameter1_edit as a double

update_edit_and_plot(gcbo,gcbf);


% --- Executes during object creation, after setting all properties.
function kernel_method_parameter2_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to kernel_method_parameter2_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function kernel_method_parameter2_edit_Callback(hObject, eventdata, handles)
% hObject    handle to kernel_method_parameter2_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of kernel_method_parameter2_edit as text
%        str2double(get(hObject,'String')) returns contents of kernel_method_parameter2_edit as a double

% in case of kernel PCA maximum value is number of points.

update_edit_and_plot(gcbo,gcbf);


% --- Executes on button press in kernel_method_parameter2_inc_pushbutton.
function kernel_method_parameter2_inc_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to kernel_method_parameter2_inc_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

km_popup = findobj(gcbf,'Tag','kernel_method_popupmenu');
par2_edit = findobj(gcbf,'Tag','kernel_method_parameter2_edit');
kernel_method = get(km_popup,'Value');
ud = get(gcbf,'Userdata');
val = round(get(par2_edit,'Value'));
%disp(['current value:',num2str(val)]);
if kernel_method == 4 % kernel perceptron
%  no maximum
  nval = val+1;
  nval = max(1,nval);
%  disp(['new value:',num2str(nval)]);
  set(par2_edit,'String',num2str(nval));  
  update_edit_and_plot(par2_edit,gcbf);
end;
if kernel_method == 5 % kernel PCA -> cyclical behaviour
  % maximum is number of samples
  nval = val+1;
  if nval > length(ud.y)
    nval = 1;
  end;
  %  nval = min(val+1,length(ud.y));
  %  nval = max(1,nval);
  %  disp(['new value:',num2str(nval)]);
  set(par2_edit,'String',num2str(nval));  
  update_edit_and_plot(par2_edit,gcbf);
end;


% --- Executes on button press in kernel_method_parameter2_dec_pushbutton.
function kernel_method_parameter2_dec_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to kernel_method_parameter2_dec_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

km_popup = findobj(gcbf,'Tag','kernel_method_popupmenu');
par2_edit = findobj(gcbf,'Tag','kernel_method_parameter2_edit');
kernel_method = get(km_popup,'Value');
ud = get(gcbf,'Userdata');
val = round(get(par2_edit,'Value'));
%disp(['current value:',num2str(val)]);
if kernel_method == 4 % kernel perceptron
  % no maximum
  nval = max(1,val-1);
%  disp(['new value:',num2str(nval)]);
  set(par2_edit,'String',num2str(nval));  
  update_edit_and_plot(par2_edit,gcbf);
end;
if kernel_method == 5 % KPCA, cyclical behaviour
  % maximum is number of samples
  nval = val-1;
  if nval<=0
    nval = length(ud.y);
  end;
  nval = max(1,nval);
  %  nval = min(nval,length(ud.y));
  %  disp(['new value:',num2str(nval)]);
  set(par2_edit,'String',num2str(nval));  
  update_edit_and_plot(par2_edit,gcbf);
end;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%% "data points" options and uicontrols  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on button press in data_points_set_class1_pushbutton.
function data_points_set_class1_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to data_points_set_class1_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
ud = get(gcbf,'userdata');
ud.plot_point_mode = 'class1';
set(gcbf,'userdata',ud);

%plot_invariant_kernel_method(gcbf);

% --- Executes during object creation, after setting all properties.
function data_points_set_class1_pushbutton_CreateFcn(hObject, eventdata, handles)
% hObject    handle to data_points_set_class1_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes during object creation, after setting all properties.
function data_points_set_class2_pushbutton_CreateFcn(hObject, eventdata, handles)
% hObject    handle to data_points_set_class1_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on button press in data_points_set_class2_pushbutton.
function data_points_set_class2_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to data_points_set_class2_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

ud = get(gcbf,'userdata');
ud.plot_point_mode = 'class2';
set(gcbf,'userdata',ud);

%plot_invariant_kernel_method(gcbf);

% --- Executes during object creation, after setting all properties.
function data_points_clear_pushbutton_CreateFcn(hObject, eventdata, handles)
% hObject    handle to data_points_clear_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% --- Executes on button press in data_points_clear_pushbutton.
function data_points_clear_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to data_points_clear_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

ud = get(gcbf,'userdata');
ud.X = [];
ud.y = [];
set(gcbf,'userdata',ud);

plot_invariant_kernel_method(gcbf);


% --- Executes on button press in data_points_load_pushbutton.
function data_points_load_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to data_points_load_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
ud = get(gcf,'userdata');
[fn,pth] = uigetfile('*.mat');
if fn
  a = load(fullfile(pth,fn));
  if ~isfield(a,'X') | ~isfield(a,'y')
    disp('file does not contain point data.');
    return;
  end;
  ud.X = a.X;
  ud.y = a.y;
  set(gcf,'userdata',ud);
else % no file selected
  return;
end;
plot_invariant_kernel_method(gcf);


% --- Executes during object creation, after setting all properties.
function data_points_load_pushbutton_CreateFcn(hObject, eventdata, handles)
% hObject    handle to data_points_load_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on button press in data_points_save_pushbutton.
function data_points_save_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to data_points_save_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
ud = get(gcf,'userdata');
[fn,pth] = uiputfile('*.mat');
if fn
  X = ud.X;
  y = ud.y;
  save(fullfile(pth,fn),'X','y');
else % no file selected
  disp('no filename given, data is not saved!');
  return;
end;

% --- Executes during object creation, after setting all properties.
function data_points_save_pushbutton_CreateFcn(hObject, eventdata, handles)
% hObject    handle to data_points_save_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%% function specific implementations
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function update_edit_and_plot(oh,fh);
% ensures that the value and string are correctly set according to
% current numeric value
if isequal(get(oh,'Style'),'edit'); % some edit fields turn to popupmenu!
  c = get(oh,'String');
  if iscell(c)
    c = c{1};
  end;
  val = str2num(c);
  set(oh,'String',num2str(val));
  set(oh,'Value',val);
end;
plot_invariant_kernel_method(fh);

%%%%  ButtonDown-Function of axes and surface:
function point_clicked(dummy1,dummy2,dummy3)
%disp('point_clicked executed!')
ud = get(gcf,'userdata');
cp = get(gca,'currentPoint');
cp = cp(1,1:2);
%disp(cp);
hold on;
switch ud.plot_point_mode
 case 'origin'
  ud.origin = cp';
  c = '';
  ud.plot_point_mode = '';
 case 'center'
  ud.center = cp';
  c = '';
%  ud.plot_point_mode = '';
 case 'class1'
  ud.X = [ud.X,cp'];
  ud.y = [ud.y,1];
  c = 'ro';
  plot(cp(1),cp(2),c);
 case 'class2'
  ud.X = [ud.X,cp'];
  ud.y = [ud.y,-1];
  c = 'bo';
  plot(cp(1),cp(2),c);
 otherwise
  return
end
set(gcf,'userdata',ud);
plot_invariant_kernel_method(gcf);  

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%  Main function performing the plotting           %%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function plot_invariant_kernel_method(fh, force);

if nargin==1
  force = 0;
end;

if force==0 & ...
	 get(findobj(fh,'Tag','plot_mode_immediate_checkbox'),'Value')==0
  return
end;

kernel_plot = findobj(fh,'Tag','kernel_plot');
colorbar_plot = findobj(fh,'Tag','colorbar_plot');
if isempty(colorbar_plot)
  disp('did not find colorbar_plot, using ''Colorbar'' instead!!');
  colorbar_plot = findobj(fh,'Tag','Colorbar');
%  keyboard;
end;

% delete old colorbar
tmp = get(colorbar_plot,'Userdata');
if ~isempty(tmp)
%  delete(tmp.PlotHandle);
  set(colorbar_plot,'Userdata',[]);
end;

axes(colorbar_plot);
cla;
axes(kernel_plot);
cla;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%  Collect main popup-settings and other interactives %%%%%%%%%

kernel_type = get(findobj(fh,'Tag','kernel_type_popupmenu'), ...
		  'Value');
transformation = get(findobj(fh,'Tag','transformation_popupmenu'),'Value');
base_kernel_type = get(findobj(fh,'Tag','base_kernel_type_popupmenu'),'Value');
plot_mode = get(findobj(fh,'Tag','plot_mode_popupmenu'),'Value');
kernel_method =  get(findobj(fh,'Tag','kernel_method_popupmenu'),'Value');

plot_trafos_visible = ...
   get(findobj(fh,'Tag','transformation_plot_checkbox'),'Visible');
plot_trafos = plot_trafos_visible & ...
    (get(findobj(fh,'Tag','transformation_plot_checkbox'),'Value')==1);
plot_tangents_visible = ...
   get(findobj(fh,'Tag','kernel_plot_tangents_checkbox'),'Visible');
plot_tangents = isequal(plot_tangents_visible,'on') & ...
	(get(findobj(fh,'Tag','kernel_plot_tangents_checkbox'),'Value')==1);

ud = get(fh,'userdata');
%disp(ud.origin);
% contains X: columnwise collection of points, y: vector of labels
% center of the transformations and origin to be used for DS-kernels

%if kernel_type > 3
%  error('kernel type not yet implemented');
%end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%% Generate train and test-kernel matrix %%%%%%%%%%%%%%%%%%%

% set up training and testing points

set(gca,'ButtonDownFcn','KerMet_Toy(''point_clicked'',0,0,0)');
if isempty(ud.X); % nothing to do if no training points
  return;
end;
% training points:
samples1 = ud.X;
labels1 = ud.y;
if (size(ud.X,2) > 1) & kernel_method ==1
  disp('only respecting last point for single kernel plot!')
  samples1 = ud.X(:,end); 
  labels1 = ud.y(end); 
end;

% test points:
grid_resolution = get(findobj(fh,'Tag','plot_mode_grid_resolution_edit'),...
		      'Value'); 
x = -1:(3/grid_resolution):2;
y = -1:(3/grid_resolution):2;
[X,Y] = meshgrid(x,y);
samples2 = [X(:)';Y(:)'];

% generate training and test kernel matrix

% set up base-kernel-parameters
switch base_kernel_type
 case 1, % linear
  params.b = get(findobj(fh,'Tag','base_kernel_parameter_1_edit'),'Value'); 
  ud.b = params.b;
  kf_name = 'linear_kernel_matrix';
 case 2, % polynomial
  params.b = get(findobj(fh,'Tag','base_kernel_parameter_1_edit'),'Value');
  ud.b = params.b;
  params.deg = get(findobj(fh,'Tag','base_kernel_parameter_2_edit'),'Value');
  ud.deg = params.deg;
  kf_name = 'poly_kernel_matrix';
 case 3, % gaussian
  params.gamma = get(findobj(fh,'Tag','base_kernel_parameter_1_edit'),'Value');
  ud.gamma = params.gamma;
  kf_name = 'rbf_kernel_matrix';
 case 4, % negative-dist
  params.beta = get(findobj(fh,'Tag','base_kernel_parameter_1_edit'),'Value');
  ud.beta = params.beta;
  kf_name = 'tria_kernel_matrix';
 case 5, % pseudo-euclidean inner product 
  params.b = get(findobj(fh,'Tag','base_kernel_parameter_1_edit'), ...
		 'Value');
  ud.b = params.b;
  params.p = get(findobj(fh,'Tag','base_kernel_parameter_2_edit'), ...
		 'Value');
  ud.p = params.p;
  kf_name = 'pseudo_euclidean_kernel_matrix';
end;

params.center = ud.center;
switch transformation
 case 1
  params.transform_names = {};
 case 2
  params.transform_names = {'dx'};
  params.dx = get(findobj(fh,'Tag','transformation_parameter_1_edit'),'Value');
  ud.dx = params.dx;
 case 3
  params.transform_names = {'dy'};
  params.dy = get(findobj(fh,'Tag','transformation_parameter_1_edit'),'Value');
  ud.dy = params.dy;
 case 4
  params.transform_names = {'dxy'};
  params.dxy = ...
       get(findobj(fh,'Tag','transformation_parameter_1_edit'),'Value');
  ud.dxy = params.dxy;
 case 5
  params.transform_names = {'phi'};
  params.phi = ...
      get(findobj(fh,'Tag','transformation_parameter_1_edit'),'Value');
  ud.phi = params.phi;
 case 6
  params.transform_names = {'scale'};
  params.scale = ...
      get(findobj(fh,'Tag','transformation_parameter_1_edit'),'Value');
  ud.scale = params.scale;
 case 7
  params.transform_names = {'dphi'};
  params.dphi = ...
      get(findobj(fh,'Tag','transformation_parameter_1_edit'),'Value');
  ud.dphi = params.dphi;
 case 8
  params.transform_names = {'dxy','phi'};  
  params.dxy = ...
      get(findobj(fh,'Tag','transformation_parameter_1_edit'),'Value');
  ud.dxy = params.dxy;
  params.phi = ...
      get(findobj(fh,'Tag','transformation_parameter_2_edit'), ...
	  'Value');
  ud.phi = params.phi;
end;
params.eps = 0; 
if get(findobj(fh,'Tag','transformation_reflection_checkbox'),'Value')==1
  params.transform_names = [{'eps'},params.transform_names];
  params.eps = 1; 
end;
set(fh,'userdata',ud); % save base-kernel and trafo- GUI-parameters

params.datasetname = '2D';

if ismember(kernel_type,[3,4]) % TD or IDS-kernels
  % change kfnname to "_DS" version and set DS parameters
  p = findstr(kf_name,'_');
  kf_name = [kf_name(1:p(1)),'DS_',kf_name(p(1)+1:end)];
  params.origin = ud.origin;
  params.regpar = get(findobj(fh,'Tag','kernel_parameter_2_edit'),'Value');
  % error if pseudo-euclidean base-kernel:
  if base_kernel_type == 5 
    disp(['Distance substitution not implemented for pseudo-Euclidean ',...
	  'inner product!']);
    return;
  end;
end;

if kernel_type == 4  % TD-Kernels      
  % fill tangent parameters
  params.Dsq_func = 'TDsq_matrix';
  params.normalize = get(findobj(fh,'Tag','kernel_parameter_3_text'),'Value');
  TDtypes = {'2S','1S','MN','MP'}; 
  ud.nTDtype = get(findobj(fh,'Tag','kernel_parameter_1_edit'),'Value');
  params.TDtype = TDtypes{ud.nTDtype};
  set(fh,'userdata',ud);
  params.pre_comp_tang2 = 1;
  params.tangent_names = params.transform_names;
  c = {'c','c'};
  params.tangent_modes = c(1:length(params.tangent_names)); 
end;

if kernel_type == 3  % IDS-Kernels      
  params.Dsq_func = 'IDsq_matrix';
end;

if kernel_type == 2 % TI-Kernels
  params.kernel_matrix_func = kf_name;
  kf_name = 'HI_kernel_matrix';
end;

if ismember(kernel_type,[2,3])   % TI-Kernels or IDS-kernels
  % set transformation parameters
  params.transform_min = zeros(length(params.transform_names),1);
  params.transform_max = zeros(length(params.transform_names),1);
  params.transform_nfeval = zeros(length(params.transform_names),1);
  nfeval = ...
      get(findobj(fh,'Tag','kernel_parameter_1_edit'),'Value');
  nfeval = round(nfeval);
  if round(nfeval)<=0
    disp('positive nfeval required, setting to 3');
    nfeval = 3;
  end;
  ud.nfeval = nfeval;
  set(fh,'userdata',ud);
  for ti = 1:length(params.transform_names)
    if ~isequal(params.transform_names{ti},'eps')
      params.transform_nfeval(ti) = nfeval;
      params.transform_min(ti) = ...
	  -getfield(params,params.transform_names{ti});
      params.transform_max(ti) = ...
	  getfield(params,params.transform_names{ti});
    else
      params.transform_nfeval(ti) = 2;
      params.transform_min(ti) = 0;
      params.transform_max(ti) = 1;
    end;
  end;
end;

kernel_data = [];
kernel_data.Ktraintrain = 0;
kernel_data.Ktraintraindiag = 0;
kernel_data.Ktraintest = 0;
kernel_data.Ktesttestdiag = 0;
kernel_data.labels = labels1(:);

watchon;
%%disp('T: setting up train and test matrices');

switch kernel_method
 case 1 % single kernel
  kernel_data.Ktraintest = feval(kf_name,samples1,samples2,params);
 case 2 % kernel k-nearest neighbour
  kernel_data.Ktraintest = feval(kf_name,samples1,samples2,params);
  for sa = 1:size(samples1,2)
    kernel_data.Ktraintraindiag(sa) = feval(kf_name,samples1(:,sa),...
					    samples1(:,sa),params);
  end;
  for sa = 1:size(samples2,2)
   kernel_data.Ktesttestdiag(sa) = feval(kf_name,samples2(:,sa),samples2(:,sa),params);
  end;
 case 3 % C-SVM
  kernel_data.Ktraintrain = feval(kf_name,samples1,samples1,params);
  kernel_data.Ktraintest = feval(kf_name,samples1,samples2,params);
 case 4 % kernel Perceptron
  kernel_data.Ktraintrain = feval(kf_name,samples1,samples1,params);
  kernel_data.Ktraintest = feval(kf_name,samples1,samples2,params);
 case 5 % KPCA
  kernel_data.Ktraintrain = feval(kf_name,samples1,samples1,params);
  kernel_data.Ktraintest = feval(kf_name,samples1,samples2,params);
 case 6 % nu novelty detection
  kernel_data.Ktraintrain = feval(kf_name,samples1,samples1,params);
  kernel_data.Ktraintest = feval(kf_name,samples1,samples2,params);
  for sa = 1:size(samples2,2)
    kernel_data.Ktesttestdiag(sa) = feval(kf_name,samples2(:,sa),...
					  samples2(:,sa),params);
  end;
 otherwise
  disp('computation of kernel matrix not implemented for kernel method')
end;

watchoff;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%% perform kernel method training %%%%%%%%%%%%%%%%%%%%%%%%%%

params.epsilon = 1e-5; 
tparams = [];

watchon;
%disp('T: training kernel method');

switch kernel_method
 case 1 % Single kernel, nothing to be done
 case 2 % Kernel k-nearest neighbour, nothing to be done
 case 3 % C-SVM: setup and solve QP
  params.C = get(findobj(fh,'Tag','kernel_method_parameter1_edit'),...
		 'Value');
  ud.C = params.C;
  set(fh,'userdata',ud);
  tparams = train_two_class_C_SVM(kernel_data, params); 
  
  %%% if train-results are required for later evaluation, they
  %%% can be stored in the GUI by the following lines:
  % ud.alpha = tparams.alpha;
  % set(fh,'userdata',ud);
  %%% end of storing the training-results
 
 case 4 % kernel perceptron with bias
  params.max_nupdates = ...
      get(findobj(fh,'Tag','kernel_method_parameter2_edit'),'Value');
  ud.max_nupdates = params.max_nupdates;
  set(fh,'userdata',ud);
  tparams = train_kernel_perceptron(kernel_data, params);
 case 5 % KPCA: eigendecomposition of centered kernel matrix
  tparams = train_kernel_PCA(kernel_data, []);
 case 6 % novelty detection by nu-hypersphere
  params.nu = get(findobj(fh,'Tag','kernel_method_parameter1_edit'),...
		  'Value');
  ud.nu = params.nu;
  set(fh,'userdata',ud);
  tparams = train_nu_hypersphere(kernel_data,params);
 otherwise
  disp('kernel method training not yet implemented');
end;

watchoff;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%% perform kernel method prediction  %%%%%%%%%%%%%%%%%%%%%%%

watchon;
%disp('T: predicting kernel method');

switch kernel_method
 case 1 % single kernel, transform kernel values for plotting
  plot_values = kernel_data.Ktraintest;
 case 2 % kernel k-nearest neighbour 
  tparams.nneigh = get(findobj(fh,'Tag','kernel_method_parameter1_edit'),...
	       'Value');
  ud.nneigh = tparams.nneigh;
  set(fh,'userdata',ud);
  pred = predict_kernel_nearest_neighbour(kernel_data,tparams);
  plot_values = pred.certainty.*pred.labels;
 case 3 % C-svm, (can be done by one-liner) ;-)
  pred = predict_two_class_C_SVM(kernel_data,tparams);
  plot_values = pred.values;

  %%% if train-predictions are required for later evaluation, they
  %%% can be stored in the GUI by the following lines:
  % kernel_data_temp.Ktraintrain = kernel_data.Ktraintrain;
  % kernel_data_temp.Ktraintest = kernel_data.Ktraintrain;
  % kernel_data_temp.Ktesttestdiag = diag(kernel_data.Ktraintrain);
  % kernel_data_temp.labels = kernel_data.labels;
  % ud.pred = predict_two_class_C_SVM(kernel_data_temp,tparams);
  % set(fh,'userdata',ud);
  % clear('kernel_data_temp');
  %%% end of storing the training predictions
 
 case 4 % kernel perceptron, (identical to C_SVM!! ) 
  pred = predict_kernel_perceptron(kernel_data,tparams);
  plot_values = pred.values;
 case 5 % KPCA
  tparams.KPCAind = get(findobj(fh,'Tag','kernel_method_parameter2_edit'),...
	       'Value');
  ud.KPCAind = tparams.KPCAind;
  set(fh,'userdata',ud);
  pred = predict_kernel_PCA(kernel_data,tparams);
  plot_values = pred.projections;
 case 6 % nu novelty detection, solution in alpha and bias 
  pred = predict_nu_hypersphere(kernel_data,tparams);
  plot_values = pred.values;

  %%% if train-predictions are required for later evaluation, they
  %%% can be stored in the GUI by the following lines:
  % kernel_data_temp.Ktraintrain = kernel_data.Ktraintrain;
  % kernel_data_temp.Ktraintest = kernel_data.Ktraintrain;
  % kernel_data_temp.Ktesttestdiag = diag(kernel_data.Ktraintrain);
  % ud.pred = predict_nu_hypersphere(kernel_data_temp,tparams);
  % set(fh,'userdata',ud);
  % clear('kernel_data_temp');
  %%% end of storing the training predictions
 
 otherwise
  disp('kernel method prediction not yet implemented');
  plot_values = zeros(1,length(y)*length(x));
end;

watchoff;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%% plot results %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% set plot_parameters depending on kernel method: colormap,
% plot_dec_line, symmetric_clim, plot_SVs, plot_margin,
% discriminant_colormap 

axes(kernel_plot);

Zplot = reshape(plot_values,length(y),length(x));
switch kernel_method
 case 1 
  plot_dec_line = 0;
  symmetrize_clim = 0;
  plot_SVs=0;
  plot_margin=0;
  discriminant_colormap =0;
  ignore_labels = 1;
 case 2 % kernel nearest neighbour
  plot_dec_line = 1;
  symmetrize_clim = 1;
  plot_SVs=0;
  plot_margin=0;
  discriminant_colormap =1;
  ignore_labels = 0;
 case 3 % C-SVM
  plot_dec_line = 1;
  symmetrize_clim = 1;
  plot_SVs=1;
  plot_margin=1;
  discriminant_colormap =1;
  ignore_labels = 0;
 case 4 % C-SVM
  plot_dec_line = 1;
  symmetrize_clim = 1;
  plot_SVs=1;
  plot_margin=0;
  discriminant_colormap =1;
  ignore_labels = 0;
 case 5 % KPCA
  plot_dec_line = 1; % is line passing through center of mass!!
  symmetrize_clim = 0;
  plot_SVs=0;
  plot_margin=0;
  discriminant_colormap =0;
  ignore_labels = 1;
 case 6 % novelty detection
  plot_dec_line = 1; 
  symmetrize_clim = 1;
  plot_SVs=1;
  plot_margin=0;
  discriminant_colormap =1;
  ignore_labels = 1;
 otherwise
  disp('plotting parameters not set for kernel method');
  return;
end;

watchon;
%disp('T: plotting results');

if discriminant_colormap ==1
  % discriminative colormap: cyan, orange
  cms = 64; % size of one half of cm
  cm1 = zeros(cms,3); 
  cm1(1,:) = [0.5 1 1]; % light cyan
  cm1(cms,:) = [0 0.3 0.3]; % dark cyan		    
  cm1 = (0:1/(cms-1):1)'*cm1(cms,:)+(1-(0:1/(cms-1):1)')*cm1(1,:);
  cm2 = zeros(cms,3); 
  cm2(1,:) = [0.3 0.3 0]; % dark orange
  cm2(cms,:) = [1 1   0]; % light orange
  cm2 = (0:1/(cms-1):1)'*cm2(cms,:)+(1-(0:1/(cms-1):1)')*cm2(1,:);
  colormap([cm1;cm2]);
else
  colormap(jet(64));
end;

%%%%% plot surface and colorbar_plot
if plot_mode == 1
  p = surf(x,y,Zplot);
else
%  keyboard;
  p = pcolor(x,y,Zplot);
%  set(p,'markeredgecolor','none');
%  set(p,'linestyle','none')  
  shading('interp');
  if symmetrize_clim
    cl = get(gca,'Clim');
    set(gca,'Clim',[-max(abs(cl)),max(abs(cl))]);
  end;
end;
set(p,'ButtonDownFcn','KerMet_Toy(''point_clicked'',0,0,0)');

%axes(colorbar_plot);
colorbar(colorbar_plot,'peer',kernel_plot);
% by this action, the tag is lost, so tag must be set immediately
set(colorbar_plot,'Tag','colorbar_plot')
%axes(colorbar_plot);
%cla;
%colorbar;

axes(kernel_plot);
xlabel('X');
ylabel('Y');
zlabel('Z');

% plot contour lines
if plot_dec_line
  hold on;
  [cn,hn] = contour(Zplot,[0 0],'w-');
% this line must be called for all plotted objects!!!
% otherwise no point-clicking is possible
  set(hn,'ButtonDownFcn','KerMet_Toy(''point_clicked'',0,0,0)');

  % scale coordinates to x,y:
  for i = 1:length(hn)
    Xdata = get(hn(i),'Xdata');
    Ydata = get(hn(i),'Ydata');
    Xdata = (Xdata-1)/(length(x)-1)*(max(x)-min(x))+min(x);
    Ydata = (Ydata-1)/(length(y)-1)*(max(y)-min(y))+min(y);
    set(hn(i),'Xdata',Xdata);
    set(hn(i),'Ydata',Ydata);
    %    keyboard;
    set(hn(i),'LineWidth',1);
  end;
end;

if plot_margin
  hold on;
  [cn,hn] = contour(Zplot,[-1,1],'w-.');
% this line must be called for all plotted objects!!!
% otherwise no point-clicking is possible
  set(hn,'ButtonDownFcn','KerMet_Toy(''point_clicked'',0,0,0)');
  for i = 1:length(hn)
    Xdata = get(hn(i),'Xdata');
    Ydata = get(hn(i),'Ydata');
    Xdata = (Xdata-1)/(length(x)-1)*(max(x)-min(x))+min(x);
    Ydata = (Ydata-1)/(length(y)-1)*(max(y)-min(y))+min(y);
    set(hn(i),'Xdata',Xdata);
    set(hn(i),'Ydata',Ydata);
    set(hn(i),'LineWidth',1);
  end;
end;
%%%%% plot training points
hold on;
if ignore_labels
  c1 = 'ko';
  c2 = 'ko';
else
  c1 = 'ro';
  c2 = 'bo';
end;

for tp = 1:size(samples1,2);
  if labels1(tp) ==1
    pp = plot(samples1(1,tp),samples1(2,tp),c1,'Linewidth',2);
  else
    pp = plot(samples1(1,tp),samples1(2,tp),c2,'Linewidth',2);
  end;
% this line must be called for all plotted objects!!!
% otherwise no point-clicking is possible
  set(pp,'ButtonDownFcn','KerMet_Toy(''point_clicked'',0,0,0)');
end;

if plot_SVs
  hold on;
  for tp = 1:size(samples1,2);
    if tparams.alpha(tp)>params.epsilon
      if labels1(tp) ==1
	pp= plot(samples1(1,tp),samples1(2,tp),c1,'Linewidth',4);
      else
	pp =plot(samples1(1,tp),samples1(2,tp),c2,'Linewidth',4);
      end;
      % this line must be called for all plotted objects!!!
      % otherwise no point-clicking is possible
      set(pp,'ButtonDownFcn','KerMet_Toy(''point_clicked'',0,0,0)');
    end;
  end;
end;


%%%%% plot trafos for all training points with black lines
nplotsteps = 50;
if plot_trafos
  otn = params.transform_names;
  for i = 1:length(otn) % draw one curve of transformed points
    for sa = 1:size(samples1,2)
      params.transform_names = otn(i);
      oldpar = getfield(params,otn{i});
      tsample = zeros(2,0);
      for par = -oldpar:(oldpar/nplotsteps):oldpar
	params = setfield(params,otn{i},par);
	tsample = [tsample, transform_vectors(samples1(:,sa),params)];
      end;
      if isequal(otn{i},'eps')
	lst = ':';
      else
	lst = '-';
      end;
      l = line(tsample(1,:),tsample(2,:),'Linestyle',lst,'Linewidth',1,...
	       'Color',[0 0 0],'Marker','none');
      % this line must be called for all plotted objects!!!
      % otherwise no point-clicking is possible
      set(l,'ButtonDownFcn','KerMet_Toy(''point_clicked'',0,0,0)');
      params = setfield(params,otn{i},oldpar);
    end;
  end;
end;

%%%%% plot tangents for all training points
if plot_tangents
  for sa = 1:size(samples1,2)
    ts = compute_tangents(samples1(:,sa),params);
    for i = 1:size(ts,2)
      l = arrow(samples1(:,sa),samples1(:,sa)+ ts(:,i),0.1); 
      %      l = arrow(samples1(:,sa),samples1(:,sa)+ ts(:,i),'Linewidth',2); 
      % this line must be called for all plotted objects!!!
      % otherwise no point-clicking is possible
      set(l,'ButtonDownFcn','KerMet_Toy(''point_clicked'',0,0,0)');
      %    l = line([samples1(1),samples1(1)+ts{i}(1)], ...
      %             [samples1(2),samples1(2)+ts{i}(2)],'Linewidth',2);
    end;
  end;
end;

set(kernel_plot,'Tag','kernel_plot')
set(colorbar_plot,'Tag','colorbar_plot')

hold off;

watchoff;
%disp('T: finished plot_invariant_kernel_method');
