function K = linear_kernel_matrix(samples1,samples2, ...
				  params);
% function K = linear_kernel_matrix(samples1,samples2,params);
%
% function computing a simple linear kernel matrix between the
% (column)-vectors in samples1 and samples2.
%
% If samples2 is empty, then samples2==samples1 is assumed. 
%
% required fields of params:
%    b : the bias added to the linear kernel.
%
% K(i1,i2) is the inner product <samples1(:,i1), samples2(:,i2)> + b 

% Bernard Haasdonk 20.7.2004

% check_required_fields(params,'b');

if ~isempty(samples2)
  K = samples1' * samples2 +params.b;
else
  K = samples1' * samples1 +params.b;
end;






