function nvec = normalize(vec)
% function nvec = normalize(vec)
%
% L2-normalization of individual vectors given by the columns of
% the matrix vec. If a tangent is almost zero, it is set to zero.

% Bernard Haasdonk 26.11.2004
 
nvec = vec;
if isempty(vec)
  return;
end;
n = sqrt(sum(vec.^2,1));

for i = 1:size(vec,2);
  if (n(i)<0.0001) %  detected almost zero tangent. Setting to zero
    nvec(:,i) = 0;   
  else
    nvec(:,i) = nvec(:,i)/n(i);   
  end;
end;
  
