function K = poly_DS_kernel_matrix(samples1,samples2, ...
			       params);
% function K = poly_DS_kernel_matrix(samples1,samples2, ...
%				 params);
%
% function computing polynomial distance substitution (DS) kernel
% matrix between the (column)-vectors in samples1 and samples2.
%
% If samples2 is empty, then samples2==samples1 is assumed. 
%
% required fields of params:
%    deg      : integer degree of the kernel.
%    b        : the bias added within the polynomial kernel.
%    Dsq_func : name of the squared distance function for computation of
%               distance matrix.
%
% K(i1,i2) is the specified power of the linear DS-kernel 

% Bernard Haasdonk 6.10.2004

%check_required_fields(params,'b','deg','Dsq_func');

K = (linear_DS_kernel_matrix(samples1,samples2,params)).^params.deg;



