function pred = predict_kernel_perceptron(kernel_data,tparams)
%function pred = predict_kernel_perceptron(kernel_data,tparams)
% 
% function performing kernel perceptron prediction on 
% certain kernel data. Routine simply calls C_SVM prediction, which
% is identical and has identical parameter requirements.
%
% required fields of kernel_data:
%    Ktraintest  : kernel matrix of training versus test samples
%    labels      : vector of binary labels +1,-1 of the training samples
%
% required fields of tparams (obtained from train_kernel_perceptron):
%    alpha       : vector of solution coefficients 
%    bias        : offset of linear discrimination function
% 
% resulting fields in pred:
%    values      : decision values ("distance" from hyperplane) 
%                  of test-samples
%    labels      : predicted labels of test samples

% Bernard Haasdonk 25.7.2005

% simply call SVM prediction
pred = predict_two_class_C_SVM(kernel_data,tparams);
