function K = rbf_DS_kernel_matrix(samples1,samples2, ...
			       params);
% function K = rbf_DS_kernel_matrix(samples1,samples2,params);
%
% function computing a Gaussian rbf distance substitution kernel
% matrix between the (column)-vectors in samples1 and samples2.
%
% If samples2 is empty, then samples2==samples1 is assumed. 
%
% required fields of params:
%    gamma    : the gamma of the rbf-kernel.
%    Dsq_func : name of the squared distance function for computation of
%               distance matrix.
%
% K(i1,i2) is defined as 
%     exp (-gamma*Dsq_func(samples1(:,i1),samples2(:,i2)))

% Bernard Haasdonk 22.7.2004

%check_required_fields(params,'gamma','Dsq_func');

K = exp(-params.gamma*eval([params.Dsq_func,'(samples1,samples2,params);']));




