function K = rbf_kernel_matrix(samples1,samples2, ...
			       params);
% function K = rbf_kernel_matrix(samples1,samples2,params);
%
% function computing a simple Gaussian rbf kernel matrix between the
% (column)-vectors in samples1 and samples2.
%
% If samples2 is empty, then samples2==samples1 is assumed. 
%
% required fields of params:
%    gamma : the gamma of the rbf-kernel
%
% K(i1,i2) is defined as 
%     exp (-gamma* |samples1(:,i1)- samples2(:,i2)|^2)

% Bernard Haasdonk 20.7.2004

%check_required_fields(params,'gamma');

K = exp(-params.gamma*EDsq_matrix(samples1,samples2));



